# 基础查询

## 语法

```mysql
select 查询列表 from 表名;
```

## 特点

- 查询列表可以是：表中的字段、常量值、表达式、函数
- 查询的结果是一个虚拟的表格

## 用法

### 查询表中的单个字段

```mysql
SELECT last_name FROM employees;
```

### 查询表中的多个字段

```mysql
SELECT last_name,salary,email FROM employees;
```

### 查询表中的所有字段

#### 方式1

```mysql
SELECT 
    `employee_id`,
    `first_name`,
    `last_name`,
    `phone_number`,
    `last_name`,
    `job_id`,
    `phone_number`,
    `job_id`,
    `salary`,
    `commission_pct`,
    `manager_id`,
    `department_id`,
    `hiredate` 
FROM
    employees ;
```

#### 方式2

```mysql
SELECT * FROM employees;
```

### 查询常量值

```mysql
SELECT 100;
SELECT 'john';
```

### 查询表达式

```mysql
SELECT 100 % 98;
```

### 查询函数

```mysql
SELECT VERSION();
```

## 别名

### 作用

-  便于理解
-  如果要查询的字段有重名的情况，使用别名可以区分开来

### 方式1：使用 `as`

```mysql
SELECT 100 % 98 AS 结果;
SELECT last_name AS 姓,first_name AS 名 FROM employees;
```

### 方式2：使用空格

```mysql
SELECT last_name 姓,first_name 名 FROM employees;
SELECT salary AS "out put" FROM employees;
```

## 去重

```mysql
SELECT DISTINCT department_id FROM employees;
```

## 加号的作用

- 运算符
- `select 100+90;` 两个操作数都为数值型，则做加法运算
- `select '123'+90;`只要其中一方为字符型，试图将字符型数值转换成数值型如果转换成功，则继续做加法运算
- `select 'john'+90;`如果转换失败，则将字符型数值转换成 0
- `select null+10;` 只要其中一方为null，则结果肯定为 null

## concat 函数

### 查询员工名和姓连接成一个字段，并显示为 姓名

```mysql
SELECT CONCAT('a','b','c') AS 结果;

SELECT 
	CONCAT(last_name,first_name) AS 姓名
FROM
	employees;
```

