# 数据类型

## 整型

| 类型        | 字节数 |
| ----------- | ------ |
| tinyint     | 1      |
| smallint    | 2      |
| mediumint   | 3      |
| int/integer | 4      |
| bigint      | 8      |

### 特点

- 如果不设置无符号还是有符号，默认是有符号，如果想设置无符号，需要添加 `unsigned` 关键字
- 如果插入的数值超出了整型的范围,会报 `out of range` 异常，并且插入临界值
- 如果不设置长度，会有默认的长度，长度代表了显示的最大宽度，如果不够会用 0 在左边填充，但必须搭配 `zerofill` 使用

## 小数

### 浮点型

- float(M,D)
- double(M,D)

### 定点型

- dec(M,D)
- decimal(M,D)

### 特点

- M：整数部位 + 小数部位
- D：小数部位
- 如果超过范围，则插入临界值
- M 和 D都可以省略
- 如果是 decimal，则 M 默认为 10，D 默认为 0
- 如果是 float 和 double，则会根据插入的数值的精度来决定精度
- 定点型的精确度较高，如果要求插入数值的精度较高如货币运算等则考虑使用

## 字符型

| 类型       | M                             | 特点     | 空间利用率 | 效率 |
| ---------- | ----------------------------- | -------- | ---------- | ---- |
| char(M)    | 最大字符数，可以省略，默认为1 | 固定长度 | 低         | 高   |
| varchar(M) | 最大字符数，不可省略          | 可变长度 | 高         | 低   |

## 日期型

| 类型      | 字节 | 范围      | 时区影响 |
| --------- | ---- | --------- | -------- |
| datetime  | 8    | 1000—9999 | 无       |
| timestamp | 4    | 1970-2038 | 有       |

