# 联合查询

## 语法

```mysql
查询语句1
union
查询语句2
union
...
```

## 应用场景

- 要查询的结果来自于多个表，且多个表没有直接的连接关系，但查询的信息一致时

## 特点

- 要求多条查询语句的查询列数是一致的！
- 要求多条查询语句的查询的每一列的类型和顺序最好一致
- union 关键字默认去重，如果使用 union all 可以包含重复项

## 案例

### 查询部门编号>90或邮箱包含a的员工信息

```mysql
SELECT * FROM employees  WHERE email LIKE '%a%'
UNION
SELECT * FROM employees  WHERE department_id>90;
```

### 查询中国用户中男性的信息以及外国用户中年男性的用户信息

```mysql
SELECT id,cname FROM t_ca WHERE csex='男'
UNION ALL
SELECT t_id,tname FROM t_ua WHERE tGender='male';
```

