- ConcurrentHashMap
- ConcurrentSkipListMap
- ConcurrentSkipSet
- ConcurrentLinkedQueue
- ConcurrentLinkedDeque
- CopyOnWriteArraySet
- CopyOnWriteArrayList
- ArrayBlockingQueue
- PriorityBlockingQueue
- LinkedBlockingQueue
- LinkedBlockingDeque
- SynchronousQueue
- DelayQueue
- LinkedTransferQueue

#### 总结

| BlockQueue            | Bounded  | add                                             | offer                                            | put                      | remove                             | pool                                             | element                                        | peek                       | take                                     | transfer                                     | addLast | addFirst | removeLast | removeFirst |
| --------------------- | -------- | ----------------------------------------------- | ------------------------------------------------ | ------------------------ | ---------------------------------- | ------------------------------------------------ | ---------------------------------------------- | -------------------------- | ---------------------------------------- | -------------------------------------------- | ------- | -------- | ---------- | ----------- |
| ArrayBlockingQueue    | Y        | success->return true<br />fail->throw exception | success->return true<br />fail->return false     | 如果队列已满，则会阻塞   | 移除头部元素，如果为null，抛出异常 | 移除头部元素并返回                               | 获取头部元素，如果为null抛出异常，不会删除元素 | 获取头部元素，不会删除元素 | 如果队列为空，一直等待，否则删除头部元素 |                                              |         |          |            |             |
| PriorityBlockingQueue | N        | 同offer                                         | success->return true<br />不会返回false，除非OOM | 同offer                  | 移除头部元素，如果为null，抛出异常 | 移除头部元素并返回                               | 获取头部元素，如果为null抛出异常，不会删除元素 | 获取头部元素，不会删除元素 | 如果队列为空，一直等待，否则删除头部元素 |                                              |         |          |            |             |
| LinkedBlockingQueue   | Optional | success->return true<br />fail->throw exception | success->retrurn true<br />fail->return false    | 如果队列已满，则会阻塞   | 移除头部元素，如果为null，抛出异常 | 移除头部元素并返回                               | 获取头部元素，如果为null抛出异常，不会删除元素 | 获取头部元素，不会删除元素 | 如果队列为空，一直等待，否则删除头部元素 |                                              |         |          |            |             |
| LinkedBlockingDeque   | Optional | 同addLast                                       |                                                  |                          |                                    |                                                  |                                                |                            |                                          |                                              |         |          |            |             |
| SynchronousQueue      | Y        | success->return true<br />fail->throw exception | 如果没有接受线程，返回false                      | 阻塞直到另外一个线程接受 | 移除头部元素，如果为null，抛出异常 | 移除头部元素并返回，如果元素可用不为空，反之为空 | 会永远抛出异常                                 | 直接return null            | 一直等待，有线程transfer元素             |                                              |         |          |            |             |
| DelayQueue            | N        | 同offer如果是false，抛出异常                    | 在尾部插入元素，如果为null，抛出异常             | 同offer                  | 移除头部元素，如果为null，抛出异常 | 如果没有元素或者元素没有过期，都会返回null       | 获取头部元素，如果为null抛出异常，不会删除元素 | 获取头部元素，不会删除元素 | 一直等待，有线程放入元素并且头部元素过期 |                                              |         |          |            |             |
| LinkedTransferQueue   | N        | 在尾部插入元素，永远返回true                    | 同add                                            | 同add                    | 移除头部元素，如果为null，抛出异常 | 移除头部元素并返回                               | 获取头部元素，如果为null抛出异常，不会删除元素 | 获取头部元素，不会删除元素 | 一直等待，直到有线程放进元素             | 在队列尾部插入元素，如果没有被消费则一直等待 |         |          |            |             |



