# this关键字的用法

this 是自身的一个对象，代表对象本身，可以理解为：指向对象本身的一个指针

this 的用法在 Java 中大体可以分为3种

**普通的直接引用，this 相当于是指向当前对象本身**

**形参与成员名字重名，用this来区分**

```java
public Person(String name, int age) {
    this.name = name;
    this.age = age;
}
```

**引用本类的构造函数**

```java
class Person{
    private String name;
    private int age;

    public Person() {
    }

    public Person(String name) {
        this.name = name;
    }
    public Person(String name, int age) {
        this(name);
        this.age = age;
    }
}
```
# super 关键字的用法

super 可以理解为是指向自己超（父）类对象的一个指针，而这个超类指的是离自己最近的一个父类

super 也有三种用法

- 普通的直接引用

    - 与this类似，super相当于是指向当前对象的父类的引用，这样就可以用 `super.xxx` 来引用父类的成员

- 子类中的成员变量或方法与父类中的成员变量或方法同名时，用 super 进行区分

- 引用父类构造函数

    - super（参数）：调用父类中的某一个构造函数（应该为构造函数中的第一条语句）

    - this（参数）：调用本类中另一种形式的构造函数（应该为构造函数中的第一条语句）


# this 与 super 的区别

super 引用当前对象的直接父类中的成员，（用来访问直接父类中被隐藏的父类中成员数据或函数，基类与派生类中有相同成员定义时）如：super.变量名 super.成员函数名（实参）

this 代表当前对象名（在程序中易产生二义性之处，应使用 this 来指明当前对象，如果函数的形参与类中的成员数据同名，这时需用 this 来指明成员变量名）

super() 和 this() 类似，区别是，super() 在子类中调用父类的构造方法，this() 在本类内调用本类的其它构造方法

super() 和 this() 均需放在构造方法内第一行。

尽管可以用this调用一个构造器，但却不能调用两个

this 和 super 不能同时出现在一个构造函数里面，因为 this 必然会调用其它的构造函数，其它的构造函数必然也会有 super 语句的存在，所以在同一个构造函数里面有相同的语句，就失去了语句的意义，编译器也不会通过

this() 和 super() 都指的是对象，所以，均不可以在static环境中使用。包括：static 变量，static 方法，static 语句块。

从本质上讲，this 是一个指向本对象的指针, 然而 super 是一个Java关键字