# 第三季

## Java 集合包

- 为什么在Java面试中一定会深入考察HashMap？

- 你知道HashMap底层的数据结构是什么吗？

- JDK 1.8中对hash算法和寻址算法是如何优化的？

- 你知道HashMap是如何解决hash碰撞问题的吗？

- 说说HashMap是如何进行扩容的可以吗？

## Java 并发编程

- BAT面试官为什么都喜欢问并发编程的问题？

- 说说 synchronized 关键字的底层原理是什么？

- 能聊聊你对 CAS 的理解以及其底层实现原理可以吗？

- ConcurrentHashMap 实现线程安全的底层原理到底是什么？

- 你对 JDK 中的 AQS 理解吗？AQS 的实现原理是什么？

- 说说线程池的底层工作原理可以吗？

- 那你再说说线程池的核心配置参数都是干什么的？平时我们应该怎么用？
- 如果在线程中使用无界阻塞队列会发生什么问题？

- 你知道如果线程池的队列满了之后，会发生什么事情吗？

- 如果线上机器突然宕机，线程池的阻塞队列中的请求怎么办？

- 谈谈你对Java内存模型的理解可以吗？

- 你知道Java内存模型中的原子性、有序性、可见性是什么吗？

- 能从Java底层角度聊聊 volatile 关键字的原理吗？

- 你知道指令重排以及 happens-before 原则是什么吗？

- volatile 底层是如何基于内存屏障保证可见性和有序性的？

## Spring

- 说说你对 Spring 的 IOC 机制的理解可以吗？

- 说说你对 Spring 的 AOP 机制的理解可以吗？

- 了解过 cglib 动态代理吗？他跟 jdk 动态代理的区别是什么？

- 能说说 Spring 中的 Bean 是线程安全的吗？

- Spring 的事务实现原理是什么？能聊聊你对事务传播机制的理解吗？
- 能画一张图说说 Spring Boot 的核心架构吗？

- 能画一张图说说 Spring 的核心架构吗？

- 能说说 Spring 中都使用了哪些设计模式吗？

- 能画一张图说说 Spring Web MVC 的核心架构吗？

- 能画一张图说说Spring Cloud 的核心架构吗？

## Tomcat

## JVM

- JVM中有哪几块内存区域？Java 8 之后对内存分代做了什么改进？

- 你知道 JVM 是如何运行起来的吗？我们的对象是如何分配的？

- 说说 JVM 在哪些情况下会触发垃圾回收可以吗？

- 说说 JVM 的年轻代垃圾回收算法？对象什么时候转移到老年代？

- 说说老年代的垃圾回收算法？常用的垃圾回收器都有什么？

- 你们生产环境中的 Tomat 是如何设置 JVM 参数的？如何检查 JVM 运行情况？

- 你在实际项目中是否做过 JVM GC 优化，怎么做的？

- 你知道发生 OOM 之后，应该如何排查和处理线上系统的 OOM 问题？

## 网络

- 你能聊聊 TCP/IP四层网络模型吗？OSI七层网络模型也说一下

- 浏览器请求 www.baidu.com 的全过程大概是怎么样的？

- 画一下 TCP 三次握手流程图？为啥是三次而不是二次或者四次呢？

- 聊聊 HTTP 协议的工作原理！

- 聊聊 HTTPS 的工作原理？为啥用HTTPS就可以加密通信？

- 聊聊 HTTP 的长连接的工作原理到底是啥？

## Linux

- 聊聊 Socket 的工作原理？Socket跟 TCP IP 之间是啥关系？

- 进程间是如何通信的？线程间又如何切换呢？

- 你能聊聊 BIO、NIO、AIO 分别都是啥？有什么区别？


## MySQL

- MySQL、MyISAM和 InnoDB 存储引擎的区别是啥？

- 聊聊 MySQL 的索引实现原理？各种索引你们平时都怎么用的？

- 你能说说事务的几个特性是啥？有哪几种隔离级别？

- 你能说说 MySQL 数据库锁的实现原理吗？如果死锁了咋办？

- MySQL 的 SQL 调优一般都有哪些手段？你们一般怎么做？

## 生产实践

- 线上服务器 CPU 100%了！该怎么排查、定位和解决？

- 线上机器的一个进程用 kill 命令杀不死该怎么办？磁盘空间快满了又该怎么处理？

## 场景设计

## 并发底层

- 32位 Java 虚拟机中的 long 和 double 变量写操作为何不是原子的？
- volatile 原来还可以保证 long 和 double 变量写操作的原子性

- 到底有哪些操作在 Java 规范中是不保证原子性的呢？

- 可见性涉及的底层硬件概念：寄存器、高速缓存、写缓冲器

- 深入探秘有序性：Java程序运行过程中发生指令重排的几个地方
- JIT 编译器对创建对象的指令重排以及 double check 单例实践

- 现代处理器为了提升性能的指令乱序和猜测执行的机制

- 高速缓存和写缓冲器的内存重排序造成的视觉假象
- synchronized 锁同时对原子性、可见性以及有序性的保证
- 深入分析 synchronized 是如何通过加锁保证原子性的？

- synchronized是如何使用内存屏障保证可见性和有序性的？

- 再看volatile关键字对原子性、可见性以及有序性的保证
- 高速缓存的数据结构：拉链散列表、缓存条目以及地址解码

- 结合硬件级别的缓存数据结构深入分析缓存一致性协议

- 采用写缓冲器和无效队列优化 MESI 协议的实现性能

- 硬件层面的 MESI 协议为何会引发有序性和可见性的问题？

- 内存屏障在硬件层面的实现原理以及如何解决各种问题

- 在复杂的硬件模型之上的 Java 内存模型是如何大幅简化的？

- 面试的时候如何从内存屏障、硬件层面的原理来震慑面试官

- Java虚拟机对锁的优化：锁消除、锁粗化、偏向锁、自旋锁

- CAS 是如何基于MESI协议在底层硬件层面实现加锁的？

## 系统安全性

- 能不能说说一般黑客常用的 XSS 网络攻击的原理是什么？

- 能不能说说我们经常听到的 SQL 注入攻击背后的原理是什么？
- 听说过 CSRF 攻击吗？你知道他背后的原理是什么吗？
- 如果你们的系统允许用户上传文件，可能会遭到什么样的黑客攻击？

- 让所有工程师闻声色变的 DDoS 攻击到底是什么东西？

- 基于 SYN Flood 模式的 DDoS 攻击，背后的原理是什么呢？

- 再来看看基于 DNS Query Flood 和 HTTP Flood 的 DDoS 攻击

- 在分布式架构中，Zuul 网关是如何防止网络攻击的？

## 网络与 IO

- Netty 的架构原理图能画一下吗，他是如何体现 Reactor 架构思想的？

- 能说说你对堆外内存的理解吗？JDK 底层是如何分配堆外内存的？

- JDK 是如何对堆外内存进行回收的？什么时候会发生堆外内存溢出？
- 如果不使用零拷贝技术，普通的 IO 操作在 OS 层面是如何执行的？
- 听说过 mmap 技术吗？内存映射为什么可以提升 IO 性能？

- 零拷贝技术到底是什么，他是如何提升 IO 性能的？

## 分布式架构

- 你们的分布式系统是如何进行链路监控的？说说链路追踪系统架构原理？

- 对分布式系统进行核心链路追踪的时候，链路 id 是怎么管理的？

- 聊过两阶段提交了，那么分布式事务三阶段提交的思想能说一下吗？

- 唯一 id 生成机制中的 snowflake 算法的时钟回拨问题如何解决？

- 实施灰度发布的时候，网关是可以灰度了，可是 Dubbo 服务如何进行灰度呢？

- 除了常见服务注册中心之外，你觉得 Redis 能作为服务注册中心吗？为什么以及怎么做？

## 中间件

- 我们一般到底用 ZooKeeper 来干什么事儿？
- 有哪些开源的分布式系统中使用了 ZooKeeper？

- 为什么我们在分布式系统架构中需要使用 ZooKeeper 集群？

- ZooKeeper 为了满足分布式系统的需求要有哪些特点？

- 为了满足分布式系统的需求，ZooKeeper 的架构设计有哪些特点？

- ZooKeeper集群的三种角色：Leader、Follower、Observer

- 客户端与 ZooKeeper 之间的长连接和会话是什么？

- ZooKeeper 的数据模型：znode 和节点类型

- ZooKeeper 最核心的一个机制：Watcher 监听回调

- 一个关键的问题：zk 到底通过什么协议在集群间进行数据一致性同步？

- ZAB 的核心思想介绍：主从同步机制和崩溃恢复机制

- 从 zk 集群启动到数据同步再到崩溃恢复的 ZAB 协议流程

- 采用了 2PC 两阶段提交思想的 ZAB 消息广播流程

- 停一下脚步：ZooKeeper 到底是强一致性还是最终一致性？

- ZAB 协议下一种可能存在的数据一致性问题

- 崩溃恢复时选举出来的 Leader 是如何跟其他 Follower 进行同步的？

- 对于需要丢弃的消息是如何在 ZAB 协议中进行处理的？

- 现在再来看看 ZooKeeper 的 Observer 节点是用来干什么的？

- ZooKeeper 为什么只能是小集群部署？为什么适合读多写少场景？


## 系统架构优化与设计

- 说说高并发场景下的数据库连接池应该如何进行优化？

- 如果压测的时候发现系统的 TPS 不达标，此时应该如何优化系统？

- 为什么有了 HDFS 之后，还需要 HBase 呢？

- 到底为什么把 HBase 叫做NoSQL数据库呢？

- HBase 作为一个 NoSQL 数据库，有哪些架构上的特点？

- HBase 作为NoSQL数据库，到底适用于哪些场景？

- HBase 的数据模型是什么样的？

- HBase 的物理存储格式：为啥说他是列式存储？

- 假设让你来负责微信朋友圈这样的社交系统，应该如何设计？

- 微信朋友圈是如何对好友显示权限进行控制的？

- 如何设计高并发的朋友圈点赞系统架构？

- 关于重复点赞问题以及点赞查看时效性的方案设计

- 你了解过 ThreadLocal 的内存泄漏问题以及解决方案吗？