# Java8如何对Hash算法和寻址算法的优化

##### Hash算法

```java
static final int hash(Object key) {
        int h;
        return (key == null) ? 0 : (h = key.hashCode()) ^ (h >>> 16);
    }
```

- 原始 HashCode：`1111 1111 1111 1111 1111 1010 0111 1100` 
- 右移16位（补0）：`0000 0000 0000 0000 1111 1111 1111 1111`

- 进行异或运算：`1111 1111 1111 1111 0000 0101 1000 0011`
- 转换为 int 值返回就是得到的 Hash 值了
- 对每个hash值，在低16位中，让高低16位进行了异或，让低16位同时保持了高低16位的特征，尽量避免一些 hash 值后续出现冲突

#####  寻址算法

- Java8之前：hash 值对数组长度取模，定位到数组的一个位置

- Java8之后：数组长度减去 1 与 hash值进行与运算：`tab[index = (n - 1) & hash`
  - 取模运算性能比较差
  - 与运算性能较高
  - 二者效果一致（数组长度必须是 2 的 n 次方）

> 与运算：两位同时为 1，结果才为 1，否则为 0
>
> 或运算：两个对象，一个为1，其值为 1，否则为0
>
> 异或运算：两个值不相等则结果为 1，否则为 0

