#### 遍历List的同时去除重复数据

```java
//java8之前
Set set = new HashSet();  
List<QueryData> newList = new ArrayList<>();  
for (Iterator<QueryData> iter = queryDataByactivityTimeNew.iterator(); iter.hasNext();) {  
    QueryData queryData = iter.next();  
    if (set.add(queryData.getTime())) {
        newList.add(queryData); 
    }          
}   
queryDataByactivityTimeNew.clear();  
queryDataByactivityTimeNew.addAll(newList);  
```
#### String.format()的使用

**常规类型的格式化**

String类的format()方法用于创建格式化的字符串以及连接多个字符串对象。熟悉C语言的同学应该记得C语言的sprintf()方法，两者有类似之处。format()方法有两种重载形式。

format(String format, Object... args) 新字符串使用本地语言环境，制定字符串格式和参数生成格式化的新字符串。

format(Locale locale, String format, Object... args) 使用指定的语言环境，制定字符串格式和参数生成格式化的字符串。

显示不同转换符实现不同数据类型到字符串的转换，如图所示。

| 转  换  符 | 说    明                                    | 示    例     |
| ---------- | ------------------------------------------- | ------------ |
| %s         | 字符串类型                                  | "mingrisoft" |
| %c         | 字符类型                                    | 'm'          |
| %b         | 布尔类型                                    | true         |
| %d         | 整数类型（十进制）                          | 99           |
| %x         | 整数类型（十六进制）                        | FF           |
| %o         | 整数类型（八进制）                          | 77           |
| %f         | 浮点类型                                    | 99.99        |
| %a         | 十六进制浮点类型                            | FF.35AE      |
| %e         | 指数类型                                    | 9.38e+5      |
| %g         | 通用浮点类型（f和e类型中较短的）            |              |
| %h         | 散列码                                      |              |
| %%         | 百分比类型                                  | ％           |
| %n         | 换行符                                      |              |
| %tx        | 日期与时间类型（x代表不同的日期与时间转换符 |              |

 测试用例

```
public static void main(String[] args) { 
  String str=null; 
  str=Stringformat("Hi,%s", "王力"); 
  Systemoutprintln(str); 
  str=Stringformat("Hi,%s:%s%s", "王南","王力","王张");      
  Systemoutprintln(str);              
  Systemoutprintf("字母a的大写是：%c %n", 'A'); 
  Systemoutprintf("3>7的结果是：%b %n", 3>7); 
  Systemoutprintf("100的一半是：%d %n", 100/2); 
  Systemoutprintf("100的16进制数是：%x %n", 100); 
  Systemoutprintf("100的8进制数是：%o %n", 100); 
  Systemoutprintf("50元的书打5折扣是：%f 元%n", 50*85); 
  Systemoutprintf("上面价格的16进制数是：%a %n", 50*85); 
  Systemoutprintf("上面价格的指数表示：%e %n", 50*85); 
  Systemoutprintf("上面价格的指数和浮点数结果的长度较短的是：%g %n", 50*85); 
  Systemoutprintf("上面的折扣是%d%% %n", 85); 
  Systemoutprintf("字母A的散列码是：%h %n", 'A'); 
} 
```

输出结果

```
Hi,王力 
Hi,王南:王力王张 
字母a的大写是：A  
3>7的结果是：false  
100的一半是：50  
100的16进制数是：64  
100的8进制数是：144  
50元的书打5折扣是：500000 元 
上面价格的16进制数是：0x54p5  
上面价格的指数表示：250000e+01  
上面价格的指数和浮点数结果的长度较短的是：5000  
上面的折扣是85%  
字母A的散列码是：41 
```

搭配转换符的标志，如图所示。

| 标    志 | 说    明                                                 | 示例                    | 结果             |
| -------- | -------------------------------------------------------- | ----------------------- | ---------------- |
| +        | 为正数或者负数添加符号                                   | ("%+d",15)              | +15              |
| -        | 左对齐                                                   | ("%-5d",15)             | \|15  \|         |
| 0        | 数字前面补0                                              | ("%04d", 99)            | 0099             |
| 空格     | 在整数之前添加指定数量的空格                             | ("% 4d", 99)            | \|  99\|         |
| ,        | 以“,”对数字分组                                          | ("%,f", 9999.99)        | 9,999.990000     |
| (        | 使用括号包含负数                                         | ("%(f", -99.99)         | (99.990000)      |
| #        | 如果是浮点数则包含小数点，如果是16进制或8进制则添加0x或0 | ("%#x", 99)             | ("%#o", 99)      |
| <        | 格式化前一个转换符所描述的参数                           | ("%f和%<3.2f", 99.45)   | 99.450000和99.45 |
| $        | 被格式化的参数索引                                       | ("%1$d,%2$s", 99,"abc") | 99,abc           |

 测试用例

```
public static void main(String[] args) { 
  String str=null; 
  //$使用 
  str=Stringformat("格式参数$的使用：%1$d,%2$s", 99,"abc");       
  Systemoutprintln(str);            
  //+使用 
  Systemoutprintf("显示正负数的符号：%+d与%d%n", 99,-99); 
  //补O使用 
  Systemoutprintf("最牛的编号是：%03d%n", 7); 
  //空格使用 
  Systemoutprintf("Tab键的效果是：% 8d%n", 7); 
  //使用 
  Systemoutprintf("整数分组的效果是：%,d%n", 9989997); 
  //空格和小数点后面个数 
  Systemoutprintf("一本书的价格是：% 5f元%n", 8); 
} 
```

输出结果

```
格式参数$的使用：99,abc 
显示正负数的符号：+99与-99 
最牛的编号是：007 
Tab键的效果是：    7 
整数分组的效果是：9,989,997 
一本书的价格是：80000元 
```

**日期和事件字符串格式化**

在程序界面中经常需要显示时间和日期，但是其显示的 格式经常不尽人意，需要编写大量的代码经过各种算法才得到理想的日期与时间格式。字符串格式中还有%tx转换符没有详细介绍，它是专门用来格式化日期和时 间的。%tx转换符中的x代表另外的处理日期和时间格式的转换符，它们的组合能够将日期和时间格式化成多种格式。

常见日期和时间组合的格式，如图所示。

| 转  换  符 | 说    明                    | 示    例                         |
| ---------- | --------------------------- | -------------------------------- |
| c          | 包括全部日期和时间信息      | 星期六 十月 27 14:21:20 CST 2007 |
| F          | “年-月-日”格式              | 2007-10-27                       |
| D          | “月/日/年”格式              | 10/27/07                         |
| r          | “HH:MM:SS PM”格式（12时制） | 02:25:51 下午                    |
| T          | “HH:MM:SS”格式（24时制）    | 14:28:16                         |
| R          | “HH:MM”格式（24时制）       | 14:28                            |

测试用例

```
public static void main(String[] args) { 
  Date date=new Date();                 
  //c的使用 
  Systemoutprintf("全部日期和时间信息：%tc%n",date);     
  //f的使用 
  Systemoutprintf("年-月-日格式：%tF%n",date); 
  //d的使用 
  Systemoutprintf("月/日/年格式：%tD%n",date); 
  //r的使用 
  Systemoutprintf("HH:MM:SS PM格式（12时制）：%tr%n",date); 
  //t的使用 
  Systemoutprintf("HH:MM:SS格式（24时制）：%tT%n",date); 
  //R的使用 
  Systemoutprintf("HH:MM格式（24时制）：%tR",date); 
} 
```

输出结果

```
全部日期和时间信息：星期一 九月 10 10:43:36 CST 2012 
年-月-日格式：2012-09-10 
月/日/年格式：09/10/12 
HH:MM:SS PM格式（12时制）：10:43:36 上午 
HH:MM:SS格式（24时制）：10:43:36 
HH:MM格式（24时制）：10:43 
```

定义日期格式的转换符可以使日期通过指定的转换符生成新字符串。这些日期转换符如图所示。

```
public static void main(String[] args) { 
  Date date=new Date();                   
  //b的使用，月份简称 
  String str=Stringformat(LocaleUS,"英文月份简称：%tb",date);    
  Systemoutprintln(str);                                       
  Systemoutprintf("本地月份简称：%tb%n",date); 
  //B的使用，月份全称 
  str=Stringformat(LocaleUS,"英文月份全称：%tB",date); 
  Systemoutprintln(str); 
  Systemoutprintf("本地月份全称：%tB%n",date); 
  //a的使用，星期简称 
  str=Stringformat(LocaleUS,"英文星期的简称：%ta",date); 
  Systemoutprintln(str); 
  //A的使用，星期全称 
  Systemoutprintf("本地星期的简称：%tA%n",date); 
  //C的使用，年前两位 
  Systemoutprintf("年的前两位数字（不足两位前面补0）：%tC%n",date); 
  //y的使用，年后两位 
  Systemoutprintf("年的后两位数字（不足两位前面补0）：%ty%n",date); 
  //j的使用，一年的天数 
  Systemoutprintf("一年中的天数（即年的第几天）：%tj%n",date); 
  //m的使用，月份 
  Systemoutprintf("两位数字的月份（不足两位前面补0）：%tm%n",date); 
  //d的使用，日（二位，不够补零） 
  Systemoutprintf("两位数字的日（不足两位前面补0）：%td%n",date); 
  //e的使用，日（一位不补零） 
  Systemoutprintf("月份的日（前面不补0）：%te",date); 
} 
```

输出结果

```
英文月份简称：Sep 
本地月份简称：九月 
英文月份全称：September 
本地月份全称：九月 
英文星期的简称：Mon 
本地星期的简称：星期一 
年的前两位数字（不足两位前面补0）：20 
年的后两位数字（不足两位前面补0）：12 
一年中的天数（即年的第几天）：254 
两位数字的月份（不足两位前面补0）：09 
两位数字的日（不足两位前面补0）：10 
月份的日（前面不补0）：10 
```

和日期格式转换符相比，时间格式的转换符要更多、更精确。它可以将时间格式化成时、分、秒甚至时毫秒等单位。格式化时间字符串的转换符如图所示。

| 转  换  符 | 说    明                               | 示    例       |
| ---------- | -------------------------------------- | -------------- |
| H          | 2位数字24时制的小时（不足2位前面补0）  | 15             |
| I          | 2位数字12时制的小时（不足2位前面补0）  | 03             |
| k          | 2位数字24时制的小时（前面不补0）       | 15             |
| l          | 2位数字12时制的小时（前面不补0）       | 3              |
| M          | 2位数字的分钟（不足2位前面补0）        | 03             |
| S          | 2位数字的秒（不足2位前面补0）          | 09             |
| L          | 3位数字的毫秒（不足3位前面补0）        | 015            |
| N          | 9位数字的毫秒数（不足9位前面补0）      | 562000000      |
| p          | 小写字母的上午或下午标记               | 中：下午英：pm |
| z          | 相对于GMT的RFC822时区的偏移量          | +0800          |
| Z          | 时区缩写字符串                         | CST            |
| s          | 1970-1-1 00:00:00 到现在所经过的秒数   | 1193468128     |
| Q          | 1970-1-1 00:00:00 到现在所经过的毫秒数 | 1193468128984  |

 测试代码

```
public static void main(String[] args) { 
  Date date = new Date(); 
  //H的使用 
  Systemoutprintf("2位数字24时制的小时（不足2位前面补0）:%tH%n", date); 
  //I的使用 
  Systemoutprintf("2位数字12时制的小时（不足2位前面补0）:%tI%n", date); 
  //k的使用 
  Systemoutprintf("2位数字24时制的小时（前面不补0）:%tk%n", date); 
  //l的使用 
  Systemoutprintf("2位数字12时制的小时（前面不补0）:%tl%n", date); 
  //M的使用 
  Systemoutprintf("2位数字的分钟（不足2位前面补0）:%tM%n", date); 
  //S的使用 
  Systemoutprintf("2位数字的秒（不足2位前面补0）:%tS%n", date); 
  //L的使用 
  Systemoutprintf("3位数字的毫秒（不足3位前面补0）:%tL%n", date); 
  //N的使用 
  Systemoutprintf("9位数字的毫秒数（不足9位前面补0）:%tN%n", date); 
  //p的使用 
  String str = Stringformat(LocaleUS, "小写字母的上午或下午标记(英)：%tp", date); 
  Systemoutprintln(str);  
  Systemoutprintf("小写字母的上午或下午标记（中）：%tp%n", date); 
  //z的使用 
  Systemoutprintf("相对于GMT的RFC822时区的偏移量:%tz%n", date); 
  //Z的使用 
  Systemoutprintf("时区缩写字符串:%tZ%n", date); 
  //s的使用 
  Systemoutprintf("1970-1-1 00:00:00 到现在所经过的秒数：%ts%n", date); 
  //Q的使用 
  Systemoutprintf("1970-1-1 00:00:00 到现在所经过的毫秒数：%tQ%n", date); 
} 
```

输出结果

```Java
2位数字24时制的小时（不足2位前面补0）:11 
2位数字12时制的小时（不足2位前面补0）:11 
2位数字24时制的小时（前面不补0）:11 
2位数字12时制的小时（前面不补0）:11 
2位数字的分钟（不足2位前面补0）:03 
2位数字的秒（不足2位前面补0）:52 
3位数字的毫秒（不足3位前面补0）:773 
9位数字的毫秒数（不足9位前面补0）:773000000 
小写字母的上午或下午标记(英)：am 
小写字母的上午或下午标记（中）：上午 
相对于GMT的RFC822时区的偏移量:+0800 
时区缩写字符串:CST 
1970-1-1 00:00:00 到现在所经过的秒数：1347246232 
1970-1-1 00:00:00 到现在所经过的毫秒数：1347246232773 
```
#### decimal用法

用于数据库字段精确计算的时候

#### tinyint

tinyint(1) 和 tinyint(4) 中的1和4并不表示存储长度，只有字段指定**zerofill**是有用， 如tinyint(4)，如果实际值是2，如果列指定了zerofill，查询结果就是0002，左边用0来填充。 

#### 快速对Mysql添加索引的五个方法

**注意：索引的名字一般为：idx_column_name**

##### 添加PRIMARY KEY（主键索引）

ALTER TABLE `table_name` ADD PRIMARY KEY ( `column` )

##### 添加UNIQUE(唯一索引)

ALTER TABLE `table_name` ADD UNIQUE (`column`)

##### **添加INDEX(普通索引)** 

ALTER TABLE `table_name` ADD INDEX index_name ( `column` ) 

##### **添加FULLTEXT(全文索引)** 

ALTER TABLE `table_name` ADD FULLTEXT (`column`)

##### **添加多列索引** 

ALTER TABLE `table_name` ADD INDEX index_name ( `column1`, `column2`, `column3` ) 

#### Mysql设置创建时间字段和更新时间字段自动获取时间，填充时间（MySql5.7才支持同时设置2个DEFAULT CURRENT_TIMESTAMP）

（1）–添加CreateTime 设置默认时间 CURRENT_TIMESTAMP

```mysql
ALTER TABLE `table_name`
ADD COLUMN  `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间' ;
```

（2）–修改CreateTime 设置默认时间 CURRENT_TIMESTAMP

```mysql
ALTER TABLE `table_name`
MODIFY COLUMN  `create_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间' ;
```

（3）–添加UpdateTime 设置 默认时间 CURRENT_TIMESTAMP 设置更新时间为 ON UPDATE CURRENT_TIMESTAMP

```mysql
ALTER TABLE `table_name`
ADD COLUMN `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间' ;
```

（4）–修改 UpdateTime 设置 默认时间 CURRENT_TIMESTAMP 设置更新时间为 ON UPDATE CURRENT_TIMESTAMP

```mysql
ALTER TABLE `table_name`
MODIFY COLUMN `update_time` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间' ;
```

#### 关于utf8mb4 

创建数据库时，为了获取更好的兼容性，应该总是使用 utf8mb4 而非 utf8. 对于 CHAR 类型数据，utf8mb4 会多消耗一些空间，根据 Mysql 官方建议，使用 VARCHAR 替代 CHAR。utf8mb4支持微信 Emoji 表情的存储。

#### 日志框架的选择

**SpringBoot默认：**slf4j+logback

```java
private final Logger logger = LoggerFactory.getLogger(DatasDealController.class);//当前类	
logger.info("开始更新数据...");
```

**日志级别（error最高，SpringBoot默认日志输出级别为：`info`）**

```java
 ERROR(ERROR_INT, "ERROR"), WARN(WARN_INT, "WARN"), INFO(INFO_INT, "INFO"), DEBUG(DEBUG_INT, "DEBUG"), TRACE(TRACE_INT, "TRACE");
```

#### lombok插件，简化代码

#### 经常需要变更一些参数的状态值或者设置默认值时，可以使用枚举类型

```java
@Getter//这里是使用lombok的注解，自动生成了set方法
public enum ProductStatusEnum implements CodeEnum {
    UP(0, "在架"),
    DOWN(1, "下架")
    ;

    private Integer code;

    private String message;

    ProductStatusEnum(Integer code, String message) {
        this.code = code;
        this.message = message;
    }
}

```

#### 使用BeanUtils快速赋值拷贝对象值

```java
//需求：把对象s1的属性值拷贝到S2中，注意参数的顺序，最好放最后一行，等新修改的值set进去再拷贝
BeanUtils.copyProperties(s2, s1);
```

#### 关于Springboot-JPA的save方法（是加在类上的注解）

**@DynamicInsert**属性:设置为true,设置为true,表示insert对象的时候,生成动态的insert语句,如果这个字段的值是null就不会加入到insert语句当中.默认false。

比如希望数据库插入日期或时间戳字段时，在对象字段为空的情况下，表字段能自动填写当前的sysdate。

**@DynamicUpdate**属性:设置为true,设置为true,表示update对象的时候,生成动态的update语句,如果这个字段的值是null就不会被加入到update语句中,默认false。

注意：如果不加，在进行某些字段的更新的时，需要先进行查询

```java
OrderMaster orderMaster = repository.findOne("1234567");
orderMaster.setBuyerName("cangcang");
OrderMaster result = repository.save(orderMaster);
```

#### 生成唯一主键方法

```java
    /**
     * 生成唯一的主键(在方法上加了synchronized锁)
     * 格式: 时间+随机数
     * @return
     */
    public static synchronized String genUniqueKey() {
        Random random = new Random();
        Integer number = random.nextInt(900000) + 100000;

        return System.currentTimeMillis() + String.valueOf(number);
    }
```

#### 关于单元测试的常用api

```java
assertEquals(a,b)：判断两个数据是否一致
assertNotEquals(a,b)：判断两个数据是否不一致；
assertNull（object）：查看对象是否为空
assertNotNull(object)：查看对象是否不为空；
assertTrue(...)：判断当前运行结果是否为真；
assertFalse(...)：判断当前运行结果是否为假；
```

##### Gson入门

使用Maven管理Gson，pom.xml导入gson的依赖

```xml
  <dependency>
     <groupId>com.google.code.gson</groupId>
     <artifactId>gson</artifactId>
     <version>2.3.1</version>
  </dependency>
```

 

Gson的两个基础方法

```java
toJson();
fromJson();
```

 

**Gson的创建方式一**：直接new Gson对象

```java
//使用new方法
Gson gson = new Gson();

//toJson 将bean对象转换为json字符串
String jsonStr = gson.toJson(user, User.class);

//fromJson 将json字符串转为bean对象
Student user= gson.fromJson(jsonStr, User.class);

//**序列化List**
String jsonStr2 = gson.toJson(list);

//**反序列化成List时需要使用到TypeToken getType()**
List<User> retList = gson.fromJson(jsonStr2,new TypeToken<List<User>>(){}.getType());
```
#### 将一个数组直接转换成一个List集合

```java
String[] split = new String[20];
List<String> list = Arrays.asList(split);
```

#### 将一个List集合直接转换成一个数组

```java
list.toArray(new String[list.size()]);
```



#### 判断集合是否为空

```java
CollectionUtils.isNotEmpty(list)
```

#### [ThreadLocal用法详解和原理](https://www.cnblogs.com/coshaho/p/5127135.html)

ThreadLocal用于保存某个线程共享变量：对于同一个static ThreadLocal，不同线程只能从中get，set，remove自己的变量，而不会影响其他线程的变量。

1、ThreadLocal.get: 获取ThreadLocal中当前线程共享变量的值。

2、ThreadLocal.set: 设置ThreadLocal中当前线程共享变量的值。

3、ThreadLocal.remove: 移除ThreadLocal中当前线程共享变量的值。

4、ThreadLocal.initialValue: ThreadLocal没有被当前线程赋值时或当前线程刚调用remove方法后调用get方法，返回此方法值。

#### Mysql在V5.5之前默认存储引擎是MyISAM；在此之后默认存储引擎是InnoDB 

#### 生成唯一id的一种策略

```java
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.lang.management.ManagementFactory;
import java.net.InetAddress;
import java.net.NetworkInterface;
 
/**
 * <p>名称：IdWorker.java</p>
 * <p>描述：分布式自增长ID</p>
 * <pre>
 *     Twitter的 Snowflake　JAVA实现方案
 * </pre>
 * 核心代码为其IdWorker这个类实现，其原理结构如下，我分别用一个0表示一位，用—分割开部分的作用：
 * 1||0---0000000000 0000000000 0000000000 0000000000 0 --- 00000 ---00000 ---000000000000
 * 在上面的字符串中，第一位为未使用（实际上也可作为long的符号位），接下来的41位为毫秒级时间，
 * 然后5位datacenter标识位，5位机器ID（并不算标识符，实际是为线程标识），
 * 然后12位该毫秒内的当前毫秒内的计数，加起来刚好64位，为一个Long型。
 * 这样的好处是，整体上按照时间自增排序，并且整个分布式系统内不会产生ID碰撞（由datacenter和机器ID作区分），
 * 并且效率较高，经测试，snowflake每秒能够产生26万ID左右，完全满足需要。
 * <p>
 * 64位ID (42(毫秒)+5(机器ID)+5(业务编码)+12(重复累加))
 *
 * @author Polim
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class IdWorker {
    // 时间起始标记点，作为基准，一般取系统的最近时间（一旦确定不能变动）
    private final static long twepoch = 1536141103L;
    // 机器标识位数
    private final static long workerIdBits = 5L;
    // 数据中心标识位数
    private final static long datacenterIdBits = 5L;
    // 机器ID最大值
    private final static long maxWorkerId = -1L ^ (-1L << workerIdBits);
    // 数据中心ID最大值
    private final static long maxDatacenterId = -1L ^ (-1L << datacenterIdBits);
    // 毫秒内自增位
    private final static long sequenceBits = 12L;
    // 机器ID偏左移12位
    private final static long workerIdShift = sequenceBits;
    // 数据中心ID左移17位
    private final static long datacenterIdShift = sequenceBits + workerIdBits;
    // 时间毫秒左移22位
    private final static long timestampLeftShift = sequenceBits + workerIdBits + datacenterIdBits;
 
    private final static long sequenceMask = -1L ^ (-1L << sequenceBits);
    /* 上次生产id时间戳 */
    private static long lastTimestamp = -1L;
    // 0，并发控制
    private long sequence = 0L;
 
    private final long workerId;
    // 数据标识id部分
    private final long datacenterId;
 
    public IdWorker(){
        this.datacenterId = getDatacenterId(maxDatacenterId);
        this.workerId = getMaxWorkerId(datacenterId, maxWorkerId);
    }
    /**
     * @param workerId
     *            工作机器ID
     * @param datacenterId
     *            序列号
     */
    public IdWorker(long workerId, long datacenterId) {
        if (workerId > maxWorkerId || workerId < 0) {
            throw new IllegalArgumentException(String.format("worker Id can't be greater than %d or less than 0", maxWorkerId));
        }
        if (datacenterId > maxDatacenterId || datacenterId < 0) {
            throw new IllegalArgumentException(String.format("datacenter Id can't be greater than %d or less than 0", maxDatacenterId));
        }
        this.workerId = workerId;
        this.datacenterId = datacenterId;
    }
    /**
     * 获取下一个ID
     *
     * @return
     */
    public synchronized long nextId() {
        long timestamp = timeGen();
        if (timestamp < lastTimestamp) {
            throw new RuntimeException(String.format("Clock moved backwards.  Refusing to generate id for %d milliseconds", lastTimestamp - timestamp));
        }
 
        if (lastTimestamp == timestamp) {
            // 当前毫秒内，则+1
            sequence = (sequence + 1) & sequenceMask;
            if (sequence == 0) {
                // 当前毫秒内计数满了，则等待下一秒
                timestamp = tilNextMillis(lastTimestamp);
            }
        } else {
            sequence = 0L;
        }
        lastTimestamp = timestamp;
        // ID偏移组合生成最终的ID，并返回ID
        long nextId = ((timestamp - twepoch) << timestampLeftShift)
                | (datacenterId << datacenterIdShift)
                | (workerId << workerIdShift) | sequence;
 
        return nextId;
    }
 
    private long tilNextMillis(final long lastTimestamp) {
        long timestamp = this.timeGen();
        while (timestamp <= lastTimestamp) {
            timestamp = this.timeGen();
        }
        return timestamp;
    }
 
    private long timeGen() {
        return System.currentTimeMillis();
    }
 
    /**
     * <p>
     * 获取 maxWorkerId
     * </p>
     */
    protected static long getMaxWorkerId(long datacenterId, long maxWorkerId) {
        StringBuffer mpid = new StringBuffer();
        mpid.append(datacenterId);
        String name = ManagementFactory.getRuntimeMXBean().getName();
        if (!name.isEmpty()) {
         /*
          * GET jvmPid
          */
            mpid.append(name.split("@")[0]);
        }
      /*
       * MAC + PID 的 hashcode 获取16个低位
       */
        return (mpid.toString().hashCode() & 0xffff) % (maxWorkerId + 1);
    }
 
    /**
     * <p>
     * 数据标识id部分
     * </p>
     */
    protected static long getDatacenterId(long maxDatacenterId) {
        long id = 0L;
        try {
            InetAddress ip = InetAddress.getLocalHost();
            NetworkInterface network = NetworkInterface.getByInetAddress(ip);
            if (network == null) {
                id = 1L;
            } else {
                byte[] mac = network.getHardwareAddress();
                id = ((0x000000FF & (long) mac[mac.length - 1])
                        | (0x0000FF00 & (((long) mac[mac.length - 2]) << 8))) >> 6;
                id = id % (maxDatacenterId + 1);
            }
        } catch (Exception e) {
            System.out.println(" getDatacenterId: " + e.getMessage());
        }
        return id;
    }
    
	   public static void main(String[] args) {
		   
		   IdWorker idWorker = new IdWorker();
		   for(int i = 0;i<100;i++) {
			   System.out.println(idWorker.nextId());
		   }		
	}
  }
```

#### MyBatis执行插入之后，返回id值

```java
@Insert("insert into order_info(user_id, goods_id, goods_name, goods_count,     goods_price, order_channel, status, create_date)values(#{userId}, #{goodsId}, #{goodsName}, #{goodsCount}, #{goodsPrice}, #{orderChannel},#{status},#{createDate})")
@SelectKey(keyColumn="id", keyProperty="id", resultType=long.class, before=false, statement="select last_insert_id()")
public long insert(OrderInfo orderInfo);
```

#### 批量操作注意点：

**【注意】你可以传递一个 List 实例或者数组作为参数对象传给 MyBatis。当你这么做的时 候,MyBatis 会自动将它包装在一个 Map 中,用名称再作为键。List 实例将会以“list” 作为键,而数组实例将会以“array”作为键**

#### MyBatis实现批量删除

```xml
	<delete id="delSiteById" parameterType="int[]">
        <!-- 
        forEach : 用来循环 
        collection : 用来指定循环的数据的类型,可以填的值有： array,list,map 
        item: 循环中为每个循环的数据指定一个别名 
        index : 循环中循环的下标
        open : 开始 
        close : 结束 
        separator : 数组中元素之间的分隔符 
        -->
		delete from site where site_id in
		<foreach collection="array" item="site_id" index="no" open="("
				 separator="," close=")">
			#{site_id}
		</foreach>
	</delete>
```

#### Mybatis实现批量添加

```xml
	<!-- 插入红包数据 -->
	<insert id="insertRedCode" parameterType="java.util.List">
         INSERT INTO tbl_redenvelopes
		 (red_code) 
	     values
		 <foreach collection="list" item="item" separator="," index="index">
			(#{item})
		 </foreach>
	</insert>
	
	<!-- 插入公司数据 -->
	<insert id="insertFirmData" parameterType="java.util.List">
         INSERT INTO tbl_firm
		 (name) 
	     values
		 <foreach collection="list" item="item" separator="," index="index">
			(#{item.name})
		 </foreach>
	</insert>
```

#### mybatis实现批量查询

```xml
	<!--根据站点批量查询图片信息-->
	<select id="getAllPhotosById" resultType="Pictures">
		select pictures_name,pictures_url from pictures
		where site_id in 
		<foreach collection="array" item="site_id" index="no" open="("
				 separator="," close=")">
			#{site_id}
		</foreach>
	</select>
```



#### Mybatis实现where不定项查询

```xml
    <select id="selectDataByParams" resultType="QueryData">
      SELECT ${sortId},COUNT(*) AS COUNT FROM tbl_data
        <where>
            <if test="province != null">
                province = #{province}
            </if>
            <if test="industry != null">
                AND industry = #{industry}
            </if>
            <if test="customer != null">
                AND consumerType = #{customer}
            </if>
            <if test="source != null">
                AND activityName = #{source}
            </if>
        </where>
        GROUP BY ${sortId} HAVING COUNT>=1
    </select>
```

##### 截取某个字符之前，或者之后的字符串

```java
String url = "http://phaow83uu.bkt.clouddn.com/Fk6eFS-fMRyszdOyDaPXkCWjvNWO";
final String substring = url.substring(url.lastIndexOf("/")+1);
final String substring1 = url.substring(0, url.lastIndexOf("/"));
System.out.println(substring);
System.out.println(substring1);
```

